>From 4dd789b9fa640fc0b5d594f1431c2af6f9576e63 Mon Sep 17 00:00:00 2001
From: Joseph Tulou <brezhoneg1@yahoo.fr>
Date: Mon, 2 Feb 2009 17:34:36 +0100
Subject: [PATCH] correction for libvlc to work with new vout_window_t mechanism

---
 src/video_output/vout_intf.c |   18 +++++++++++-------
 1 files changed, 11 insertions(+), 7 deletions(-)

diff --git a/src/video_output/vout_intf.c b/src/video_output/vout_intf.c
index 4145bde..fc53653 100644
--- a/src/video_output/vout_intf.c
+++ b/src/video_output/vout_intf.c
@@ -110,10 +110,6 @@ vout_window_t *vout_RequestWindow( vout_thread_t *p_vout, const char *psz_cap,
     *pi_width_hint = p_vout->i_window_width;
     *pi_height_hint = p_vout->i_window_height;
 
-    /* Check whether someone provided us with a window ID */
-    int drawable = var_CreateGetInteger( p_vout, "drawable" );
-    if( drawable ) return (void *)(intptr_t)drawable;
-
     vout_window_t *wnd = vlc_custom_create (VLC_OBJECT(p_vout), sizeof (*wnd),
                                             VLC_OBJECT_GENERIC, "window");
     if (wnd == NULL)
@@ -126,6 +122,14 @@ vout_window_t *vout_RequestWindow( vout_thread_t *p_vout, const char *psz_cap,
     wnd->pos_y = *pi_y_hint;
     vlc_object_attach (wnd, p_vout);
 
+    /* Check whether someone provided us with a window ID */
+    int drawable = var_CreateGetInteger( p_vout, "drawable" );
+    if( drawable )
+    {
+        wnd->handle.hwnd = (intptr_t)drawable;
+        return wnd;
+    } 
+
     wnd->module = module_need (wnd, psz_cap, NULL, false);
     if (wnd->module == NULL)
     {
@@ -150,15 +154,15 @@ void vout_ReleaseWindow( vout_window_t *wnd )
     if (wnd == NULL)
         return;
 
-    assert (wnd->module);
-    module_unneed (wnd, wnd->module);
+    if (wnd->module)
+        module_unneed (wnd, wnd->module);
 
     vlc_object_release (wnd);
 }
 
 int vout_ControlWindow( vout_window_t *wnd, int i_query, va_list args )
 {
-    if (wnd == NULL)
+    if (wnd == NULL || wnd->control == NULL)
         return VLC_EGENERIC;
 
     assert (wnd->control);
-- 
1.5.2.5

